
#include <io.h>
#include <stdio.h>

/*
 * On DOS (and win95, probably all FAT), using {l,f}seek to grow a
 * file guarantees that the intervening bits will be not what you
 * expect.
 */

long
wacky_lseek_for_dos (int handle, long offset, int origin)
{
  long end_pos;
  long cur_pos = _tell (handle);
  long dest;
  static char wacky_zeroes[512];

  end_pos = _lseek (handle, 0, SEEK_END);

  switch (origin) {
  case SEEK_SET:
    dest = offset;
    break;
  case SEEK_CUR:
    dest = offset + cur_pos;
    break;
  case SEEK_END:
    dest = end_pos - offset;
    break;
  }

  /* if we are trying to grow the file... */
  if (dest > end_pos) {
    int written = 0;

    cur_pos = end_pos;
    while (cur_pos  < dest) {
      written = _write (handle,
			&wacky_zeroes,
			(dest - cur_pos) < 512 ? (dest - cur_pos) : 512);
      if (written == -1) {
	return -1;
      } else { 
	cur_pos += written;
      }
    }
    return dest;
  } else {
    return (_lseek (handle, offset, origin));
  }
}

